package de.fitko.fitconnect;

import de.fitko.fitconnect.api.domain.model.metadata.Metadata;
import de.fitko.fitconnect.api.domain.model.metadata.data.Data;
import de.fitko.fitconnect.api.domain.model.submission.Submission;
import de.fitko.fitconnect.client.SenderClient;
import de.fitko.fitconnect.client.SubscriberClient;

import java.util.Collections;
import java.util.List;
import java.util.Optional;

public class TestRunner {

    public static void main(String[] args) {

        var clientId = "781f6213-0f0f-4a79-9372-e7187ffda98b";
        var secret = "PnzR8Vbmhpv_VwTkT34wponqXWK8WBm-LADlryYdV4o";

        senderSample(clientId, secret);
        subscriberSample(clientId, secret);
    }

    private static void senderSample(String clientId, String secret) {
        final Optional<Submission> sentSubmission =  SenderClient.builder()
                .authenticate(clientId, secret)
                .createSubmission(Submission.builder().build())
                .uploadAttachments(Collections.emptyList())
                .sendSubmission(Metadata.builder().build(), Data.builder().build());
    }

    private static void subscriberSample(String clientId, String secret) {
        // #1 authenticate
        var authenticatedClient = SubscriberClient.builder().authenticate(clientId, secret);

        // #2 poll for available submissions
        List<Submission> availableSubmissions = authenticatedClient.getAvailableSubmissions("someDestinationId");

        // #3 get a submission and its data
        var confirmedSubmission = authenticatedClient
                .requestSubmission(Submission.builder().build())
                .requestMetadata()
                .requestAttachments()
                .confirmSubmission();

        // access request submission data
        var attachments = confirmedSubmission.getAttachments();
        var metadata = confirmedSubmission.getMetadata();

    }

}
